local startRaid = false

local BUFFS = {
    ["22888"] = {
        name = "Rallying Cry of the Dragonslayer",
        type = "Worldbuff"
    },
    ["16609"] = {
        name = "Warchief's Blessing",
        type = "Worldbuff"
    },
    ["15366"] = {
        name = "Songflower Serenade",
        type = "Worldbuff",
    },
    ["22817"] = {
        name = "Fengus' Ferocity",
        type = "Worldbuff",
    },
    ["22820"] = {
        name = "Slip'kik's Savvy",
        type = "Worldbuff",
    },
    ["22818"] = {
        name = "Mol'dar's Moxie",
        type = "Worldbuff",
    },
    ["17628"] = {
        name = "Supreme Power",
        type = "Flask",
    },
    ["17626"] = {
        name = "Flask of the Titans",
        type = "Flask",
    },
    ["17627"] = {
        name = "Distilled Wisdom",
        type = "Flask",
    },
}

function Ragequit:GROUP_ROSTER_UPDATE()
    Ragequit:TransmitWindfuryStatus()
    if isOfficerLoaded then
        if (IsInRaid() == false) and startRaid then
            DEFAULT_CHAT_FRAME:AddMessage("Ragequit: Konvertert til Raid")
            ConvertToRaid()
            startRaid = false
        end
    end
end

function Ragequit:CheckBuffs()
    if IsInRaid() then
        local players = {}

        for i = 1, 40 do
            name, _, group = GetRaidRosterInfo(i)
            if name then
                Ragequit:CheckUnitBuffs(players,"raid" .. i)
            end
        end

        local output = ""

        for i, v in pairs(players) do
            output = output .. i .. " # "
            output = output .. table.concat(players[i], ", ") .. "\n"
        end

        local dialog = StaticPopup_Show("RQCOPY")
        local editBox = dialog.editBox
        editBox:SetText(output)
        editBox:HighlightText()
        editBox:SetFocus()
    else
        DEFAULT_CHAT_FRAME:AddMessage("Not in Raid")
    end
end

function Ragequit:CheckUnitBuffs(players, unit)
    for i = 1, 40 do
        local buffName, _, _, _, _, _, _, _, _, spellId = UnitBuff(unit, i)
        if spellId then 
            spellId = tostring(spellId)
            local trackedBuff = BUFFS[spellId]
            if trackedBuff then 
                if not players[name] then players[name] = {} end
                table.insert(players[name], trackedBuff.name)
            end
        end
    end
end

function Ragequit:GuildMembers()

    local numTotalMembers, numOnlineMaxLevelMembers, numOnlineMembers = GetNumGuildMembers();

    local str = ""
    local players = {}

    for i = 1, GetNumGuildMembers() do
        local name, rank, rankIndex, level, class = GetGuildRosterInfo(i);
        table.insert(players, stripRealm(name) .. ',' .. rank .. ',' .. class .. ',' .. level )
    end

    table.sort(players)
    table.insert(players, 1, 'Name,Rank,Class,Level')

    for player = 1, #players do
        str = str .. players[player] .. "\n"
    end
    
    local dialog = StaticPopup_Show("RQCOPY")
    local editBox = dialog.editBox
    editBox:SetText(str)
    editBox:HighlightText()
    editBox:SetFocus()
end

function Ragequit:RaidMembers()
    if(IsInRaid()) then
        local str = ""
        local players = {}

        local prefix = IsInRaid() and "raid" or "party"
        for i = 1, GetNumGroupMembers() do
            local unit = prefix .. i
            local name = UnitName(unit)

            if (name ~= nil) then
                players[i] = name
            end
        end

        table.sort(players)

        for playerCount = 1, #players do
          str = str .. players[playerCount] .. "\n"
        end
        
        local dialog = StaticPopup_Show("RQEXPORT")
        local editBox = dialog.editBox
        editBox:SetText(str)
        editBox:HighlightText()
        editBox:SetFocus()
    else
        print ("Not in Raid")
    end
end

function Ragequit:Invite(text)
    if not isEmpty(text) then
        local invite = splitString(text, ",")

        if (table.getn(invite) ~= 0) then
            startRaid = true
            DEFAULT_CHAT_FRAME:AddMessage("Starter invites")

            C_Timer.After(10, function () 
                if isOfficerLoaded then
                    if (IsInRaid() == false) and (IsInGroup() == false) then
                        startRaid = false
                    end
                end
            end)

            for i = 1, #invite do
                InviteUnit(invite[i])
            end
        end
    end
end